/* "menu.c" */
/* Time-stamp: <97/12/17 11:35:28 hgs> */

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <string.h>
#include <math.h>
#include "ranlib.h" 
#include "header.h"


/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-  
    This module creates all of the menus             
  -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
Design *design0 = &Template_Design; 
/* global variables: default values of the basic parameters */
extern int NMIN, NMAX, NUMBER_OF_ELEMENT;
extern int COHORT_SIZE;
extern double ACCRUAL_RATE;
extern double MONITOR_TIME;

static int Modified = 0;  /* 0 = no, 1 = yes */  
static int Lastmenu; 
static int Phase2a = 0;  
static int Randomized = 0;
static int Extended = NO;     /* extend the randomized trial to allow 
				 comparison between treatment arms */

/* variables for phase II A design only      */
/* for mixture prior:  share with boundary.c */
extern int MIX_K;  
extern double MIX_Design_aS[10][50], WEIGHT[10];
extern double MIX_Event_aS[10], MIX_Event_bS[10];


double TrueP[MAXP][MAX_ELEMENT];  /* store the prob vectors 
					   in simulation */

/* main menu */
void menu(int which_menu)
{ 
    FILE *fp; 
    static int Old, Arms, reassign, Again = NO;
    int i, j, k, m, n, index, option, type, tot, nmax, flag; 
    double pNull, pTrue, pp, aE, bE; 
    double value, sum, mm, width, coverprob, muS, thetanum, thetaden, prcevent;
    Event *temp;  char name[200], *one, *two, *text, buf[200];
    char *word = (char*) malloc(200 * sizeof(char)); 

/* showing menu number for testing purpose */  
    if (TEST == YES) printf("\nmenu: %d\n--------------\n", which_menu); 
    if (which_menu == 101 ) {
	initial_design(design0, NMIN, NMAX, MAX_ELEMENT, "default");
	if (design0 == NULL) {
	    printf("** Not enough memory for the program. "
		   "Please try again.\n");
	    exit(0);
	}
	printf("\n----------\nMain Menu\n----------\n"
	       "(1) Create a new design\n"
	       "(2) Use a previously created design\n"
	       "Which would you like?\n");	
	do {
	    printf("\n(Please choose 1 or 2)\n> ");        
	    option = get_an_integer();      
	} while (option != 1 && option != 2);
        if (option == 1) {  /* make new design */
	    Lastmenu = 101;  Old = 0; menu(201);
        }    
        else if (option == 2) {  /* use old design */
	    Lastmenu = 101;  Old = 1; menu(501); 
        }
    }/*--- menu(101): new or old ----------------------------------------*/
    

    else if (which_menu == 201) {  /* new design, ask for filename */
	printf("\n-----------------------------------------------\n"
	       "Output Filename = The Name of the Design\n"
	       "-----------------------------------------------\n"
	       "The filename you select will be used to save the\n"
	       "information you provide while creating the design and the\n"
	       "output information, which includes decision boundaries and\n"
	       "operating characteristics.\n" 
	       "Please do not name your design \"back\", \"quit\", or"
	       "\"exit\"\n\n"
	       "Select a filename for this new design: "
	       "(please leave no spaces)\n> ");	       
	scanf("%s", word);	    
	if (strcmp(word, "back") == 0)	 menu(101); 
	else {  /* name checking */
	    /* check illegal file path */
	    while ((fp = fopen(word, "a")) == NULL ) {
		fclose(fp);
		printf("** Can not write to file:\n   \"%s\".\n", word);
		printf("** Please check if the path is correct.\n\n"
		       "** Select another name. (leave no space, please)\n> ");
		scanf("%s", word);
	    }
	    fclose(fp); 
	    /* an empty file maybe created by fopen(), check and remove
	       this empty file */
	    text = get_file(word);
	    if (!text) remove(word); /* remove the file "word" */
	    else if ((int)strlen(text) < 10) remove(word);
	    
	    if ( (fp = fopen(word,"r")) != NULL ) {
		fclose(fp);
		printf("*** The file \"%s\" already exists.\n\n", word);
		printf("1) Overwrite the old file\n"
		       "2) Select another name for the new design\n\n"
		       "Which would you like?\n");
		do {
		    printf("\n(Please choose 1 or 2)\n> ");
		    option = get_an_integer();
		    if (option == -2 ) menu(101); 
		} while (option != 1 && option != 2);
		if (option == 2)  menu(201);
	    }	    
	    sprintf(design0->filename, "%s", word);	
	    Lastmenu = 201;  menu(202);  /* got a legitimate name, move on */ 
	}
    }/*-------------------menu(201): naming new design -------------------*/
    
    
    else if (which_menu == 202) {/* create new design: input N_of_element */
	int element;
	printf("\n----------------------\n"
	       "Creating a New Design"
	       "\n----------------------\n"
	       "Please follow the menu to specify the information required\n"
	       "to create the new design: \"%s\"\n", design0->filename);
	printf("\nEnter the number of elementary outcomes "
	       "(at least 2, at most %d):\n> ", MAX_ELEMENT);
	element = get_an_integer();
	
	if (element == -2)   menu(101); /* previous  */
	else if (element >= 2)  {
	    design0->number_of_element = element;
	    /*free(design0->aS); free(design0->aE); */
	    design0->aS = (double*) malloc(element * sizeof(double));
	    design0->aE = (double*) malloc(element * sizeof(double));
	    printf("The number of elementary outcomes is %d\n", element);
	    if (element == 2)  { 
		int k;
		printf("\nPlease choose one of the following two methods:\n\n"
		       "1) Phase IIB:\n"
		       "--------------\n"
		       "   The stopping bounds are determined by\n"
		       "   Pr[ theta_S + delta < theta_E | Data ] < p_L, or\n"
		       "   Pr[ theta_S + delta < theta_E | Data ] > p_U\n"
		       "   where theta_S is a random variable.\n\n"
		       
		       "2) Phase IIA with Binary Outcome:\n"
		       "----------------------------------\n"
		       "   The stopping bounds are determined by\n"
		       "   Pr[ theta_E > p_Null | Data ] < p_L, or\n"
		       "   Pr[ theta_E > p_Null | Data ] > p_U\n"
		       "   where p_Null is a fixed constant.\n\n");
		do {
		    printf("\nWhich design do you wish to use?\n> ");
		    k = get_an_integer();
		    if (k == 2)	 Phase2a = 1, menu(601);
		    else if (k == 1) Phase2a = 0;
		    else if (k == -2) menu(202); /* back */
		    else printf("Please choose 1 or 2.\n> ");
		} while (k < 1 || k > 2);
	    }
	    menu(301); /* move on to define compound events */
	}	
	if (element < 2) { 
	    printf("Number of elementary events should be larger than 1.\n"
		   "Try again.\n");
	    menu(202);
	}
	else menu(101);
    }/*------------------menu(202): enter no_of_element-------------*/
    
/* mixture prior for thetaS */
    else if (which_menu == 210) {
	printf("\n---------------------------\n"
	       "Standard Rx Prior Menu\n"
	       "---------------------------\n\n"
	       "You may specify the prior of theta_S in two ways:\n\n"
	       "1) Simple Dirichlet Prior:\n"
	       "---------------------------\n"
	       "theta_S ~ Dirichlet(a_S)\n\n"
	       "2) Mixture prior:\n"
	       "------------------\n"
	       "theta_S is a discrete mixture of k different\n"
	       "Dirichlet priors, formally,\n"
	       "theta_S ~ w_1*Dir(a_{S,1}) + ... + w_K*Dir(a_{S,K})\n"
	       "where w_1 + w_2 + ... + w_K = 1\n\n");
	do {
	    printf("1 = Simple Dirichlet prior for theta_S\n"
		   "2 = Mixture Dirichlet prior for theta_S\n");
	    if (Old == 1) printf("3 = Skip this menu.\n");
	    printf("\nWhich would you like?\n> ");	    
	    option = get_an_integer();
	    if (option == -2) menu(Lastmenu); /* back to 305 or 502 */
	    else if (option == 3 && Old == 1) return;  /* skip */
	} while (option != 1 && option != 2);
	if (option == 1) {
	    design0->Sprior_type = 1;   MIX_K = 1;
	    design0->Sprior_weight[0] = 1e0;
	    menu(211);  /* usual route */
	}
	else if (option == 2) menu(2101); /* do something fancy */
    }/*--------------------------------------menu(210)-------------------*/
    
    else if (which_menu == 2101) {
	printf("\n-----------------------------\n"
	       "Mixture Prior Menu\n"
	       "-----------------------------\n\n"
	     "Mixture prior: theta_S ~ w_1*Dir(a_S,1) + ... + w_K*Dir(a_S,K)\n"
	       "               where w_1 + w_2 + ... + w_K = 1\n\n"	
	       "Please specify:\n"
	       "1) K = the number of Dir() components included (max 10): > "); 
	do { 
	    k = get_an_integer();
	    if (k == -2) menu(210); /* back */
	    if (k < 2 || k > 10) printf("Please choose K between 2 and 10.\n");
	} while( k < 2 || k > 10);
	
	design0->Sprior_type = MIX_K = k;
	/* design0->Sprior_weight = (double*) malloc(k * sizeof(double)); */
	printf("2) Weight vector: ( make sure w_1 %s w_%d = 1 )\n", 
	       (k > 2)? "+...+": "+", k);
	/* sum = 1e0; */ 
	for (i=0; i< MIX_K; i++) {
	    printf("w_%d = ", i+1);
	    value = get_a_double(0e0, 1e0);
	    if ( (int)value == -2 ) menu(210); /* back */  
	    if ( (int)value >= 0 && (int)value <= 1) { /* legitimate */
		design0->Sprior_weight[i] = value;
		/* sum -= value; */
	    }
	}
	for (i = MIX_K; i<10; i++)  /* defensive programming */
	  design0->Sprior_weight[i] = -1.0;
	printf("\n\nYou have entered:\n");
	printf("K = %d,  Weights = ", design0->Sprior_type);
	for (i=0; i < design0->Sprior_type ;i++)  {
  	    printf("%.3f ", design0->Sprior_weight[i]);
	}
	printf("\n\n(1) Accept these weights\n"
	       "(2) Re-enter K and the weights\n"
	       "(3) Back to previous menu\n\n"
	       "Which would you like?\n");
	do {
	    printf("\n(Please choose 1, 2, or 3)\n> ");
	    option = get_an_integer();
	    if (option == -2 || option == 3)  menu(210); /* back*/
	} while (option < 1 || option > 3);
	if (option == 1)  menu(2102);  /* move on */
	if (option == 2)  menu(2101);  /* redo */
	
    }/*--------------------------------------end of menu(2101)-----*/

    else if (which_menu == 2102) {
      int nelem = design0->number_of_element;
	printf("\n------------------------------------------------------\n"
	       "Enter the Parameters for Each Dirichlet Distribution\n"
	       "------------------------------------------------------\n\n");
	printf("Specify the Dirichlet Parameters (a1%s a%d)\n",
	       (nelem > 2)? ",...,":",", nelem);
	for (i=0; i< design0->Sprior_type; i++) {
	    printf("For Dir_%d() of weight %.3f:\n", i+1,
		   design0->Sprior_weight[i]);
	    for (j=0; j< nelem; j++) {
		printf("a_S%d = ", j+1);
		value = get_a_double(0e0, 999e0);		
		if ((int)value == -2) menu(210);   /* jump back */	
		else {
		    MIX_Design_aS[i][j] = fabs(value); 
		    design0->mix_aS[i][j] = fabs(value);
		}
	    }
	}
	/* review */
	printf("\n\nYou have entered:\n"
	       "Prior   Weight   Parameters a_S\n"
	       "-----   ------   ----------------\n");
	for (i=0; i< design0->Sprior_type; i++){
	    printf("%2d\t%.3f\t", i+1, design0->Sprior_weight[i]);
	    for (j=0; j < nelem; j++)
	      printf("%3.3f\t", design0->mix_aS[i][j]); 
	    printf("\n");
	}
	do {
	    printf("\n(1) Accept these parameters"
		   "\n(2) Re-enter the parameters"
		   "\n(3) Back to previous menu\n> ");
	    option = get_an_integer();
	    if (option == 3 || option == -2) 
	      menu(2101); 
	    else if (option == 1)  { 
		Lastmenu = 2102; menu(221); /* move on to enter aE */ }
	    else if (option == 2)  menu(2102);
	    else printf("Please chose 1, 2, or 3.\n");
	} while(option != 1 || option != 2 || option != 3);
    }/*--------------------------------------end of menu(2102)-----*/
    
    
    /* menu 211, 212, 213, 214:  input aS or (muS, W) */
    else if (which_menu == 211) {  /* specify prior type of aS */
	int nelem;
	if (Phase2a != 0) menu(601);
	printf("\n-------------------------------\n");
	printf("Single Standard Rx Prior:\n");
        printf("-------------------------------\n\n");

	nelem = design0->number_of_element;

	printf("(1) Specify the Dirichlet Parameters a1%s a%d\n",
	       (nelem > 2)? ",...,":",", nelem);
	printf("(2) Specify %d %s and 1 dispersion parameter\n",
	       nelem - 1, (nelem > 2)? "means" : "mean" );
	printf("(3) Back to previous menu\n"
	       "(4) Skip this menu\n\n"
	       "Which way do you wish to specify the prior for theta_S?");
	do {
	    printf("\n(Please choose 1 to 4)\n> ");
	    option = get_an_integer();
	} while (option < 1 || option > 4);
	if (option == 3) /* back to previous menu */
	  if (Lastmenu == 502)  menu(502); else  menu(305);
	if (option == 4)  menu(221); /* move on */
	if (option == 1) {
	    menu(212);  /* type in aS */
	} 
	if (option == 2) {
	    menu(213);  /* type in (uS,W) */
	}
    }/*------------------menu(211): type aS or uS -----------------------*/
  
    else if (which_menu == 212) {  /* enter parameter of prior type I */
	printf("Please enter the %d Dirichlet parameters.\n",
	       design0->number_of_element);
	for (i = 0; i < design0->number_of_element; i++) {
	    printf("a_S%d = ",i+1);
	    value = get_a_double(0e0, 9999.0);		
	    if ((int)value == -2) menu(211);   /* jump back */
	  
	    design0->aS[i] = value;
	}	

	printf("\n\nYou have entered:\n");   
	for (i=0; i < design0->number_of_element; i++) 	
	  printf("a_S%d = %.4f\n", i+1, design0->aS[i]);
	do {
	    printf("\n(1) Accept these parameters"
		   "\n(2) Re-enter the parameters"
		   "\n(3) Back to previous menu: \n> ");
	    option = get_an_integer();
	} while( option < 1 || option > 3 );
	if (option == 3)  menu(211); 
	if (option == 1)  menu(221);  /* enter aE */
	if (option == 2)  menu(212);
    }/*------------------------------menu(212)-----------------------*/

    else if (which_menu == 213) {  /* different parametrization */
	for (i=0 ;i < design0->number_of_element - 1; i++)  
	  design0->muS[i] = 0e0;	
	sum = 1e0;
	printf("Please enter the prior means.\n");
	for (i=0; i < design0->number_of_element - 1; i++) {
	    printf("muS_%d = ",i+1);
	    value = get_a_double(0e0, sum);
	    if ((int)value == -2) menu(211); /* jump back */
	    if ((int)value < 0 || value > sum) {
		printf("\nMust be between 0 and %.3lf. Try again.\n", sum);
		--i;
		continue;
	    }
	    if ( value >= 0e0 && value <= sum) { /* legitimate */
		design0->muS[i] = value;
		sum -= value;
	    }
	}
	design0->muS[design0->number_of_element -1] = sum;

	printf("\n\nYou have entered: ");
	for (i=0; i < design0->number_of_element ;i++)  {
  	    printf("\n\tmuS_%d = %.4lf", i+1, design0->muS[i]);
	}
	do {
	    printf("\n\n(1) Accept these prior means"
		   "\n(2) Re-enter the means:"
		   "\n(3) Back to the previous menu:\n> ");
	    option = get_an_integer();
	} while (option < 1 || option > 3);
	if (option == 3)  menu(211); /* back*/
	if (option == 1)  menu(214);  /* move on */
	if (option == 2)  menu(213);  /* redo */
    }/*--------------------------------- menu(213) -----------*/


    else if (which_menu == 214) { /* input W,p, transform (muS, W) to aS */
	printf("\n\nSelect which compound event will correspond to the\n"
	       "dispersion parameter:\n");
	i = 1;
	for (temp = design0->event0->next; temp != NULL; temp = temp->next){
	    printf("(%d) %s\n", i, temp->name);
	    ++i;
	}
	assert(i-1 == design0->number_of_event); /* check point */
	printf("> ");
	option = get_an_integer();

	if (option >= 1 && option <= design0->number_of_event) {
	    get_event(option, design0);
	}else {
	    printf("please select between 1 and %d\n", i);
	    menu(214);
	}
	
	mm = 0e0;
	for (i=0; i<design0->number_of_element; i++)
	  if (design0->current_event->definition[i] == 1)
	    mm += design0->muS[i];
	/* mm = (mm < 1-mm)? mm : (1-mm);  */
	mm = 2 * Min(mm, 1-mm);
	
	printf("\n\nEnter W = the prior interval width for Pr[%s]\n",
	       design0->current_event->name);
	printf("(max = %.4f): > ", mm);

	value = get_a_double(0e0, mm);
	width = value;

	printf("\nEnter the Prior Interval Coverage Probability: > ");	
	value = get_a_double(0e0, 1e0);
		
	coverprob = value;

	printf("\nYou have entered:"
	       "\nCompound Event corresponding to the dispersion parameter:");
	printf(" \"%s\"\n", design0->current_event->name);
	printf("Prior Interval Width = %.4f", width);
	printf("\nPrior Interval Coverage Probability = %.4f", coverprob);
	printf("\n\nPlease select from the following:\n"
	       "(1) Accept these values\n"
	       "(2) Re-specify values for dispersion parameter: ");
	do {
	    printf("\n(Please choose 1 or 2)\n> ");
	    option = get_an_integer();
	    if (option == -2) menu(213); /* back */
	} while (option != 1 && option != 2);

	if (option == 2) menu(214); /* try again */
	else if (option == 1) {
	    getdir(design0, width, coverprob, 1); /* (mu,W,p) -> aS */
	    menu(221);   /* move on */
	}  
    }/*----------------------------------menu(214)-----------------------*/
     
 
/* menu 221, 222, 223, 224: Input parameter aE or (muE, W)  */
    else if (which_menu == 221) {  /* entering aE  */
      int nelem = design0->number_of_element;
      printf("\n-----------------------\n"
	     "Experimental Rx Prior  \n"
	     "-----------------------\n"	       
	     "We recommend \"flat prior\" method, which equates\n"
	     "the prior means of theta_E to those of theta_S, and sets\n");
      printf("aE1 %s aE%d = %d.\n\n", (nelem > 2)? "+...+" : "+", nelem, nelem);
      
      printf("(1) Use a flat prior on theta_E\n"
	     "(2) Specify the Dirichlet parameters a1%s a%d\n", 
	     (nelem > 2)? ",...," : ",", nelem );
      printf("(3) Specify %d %s and 1 dispersion parameter\n",
	     nelem - 1, (nelem > 2)? "means" : "mean"); 
      printf("(4) Back to previous menu\n"
	     "(5) Skip this menu (use old parameters).\n"
	     "Which way do you want to specify a prior for theta_E? ");
      do {
	printf("\n(Please choose 1 to 5)\n> ");
	option = get_an_integer();
      } while (option < 1 || option > 5);
	if (option == -2 || option == 4)  menu(211); /* back */
	if (option == 5) menu(231);	
       	if (option == 1) { /* compute the flat aE */
	    if ( MIX_K > 1) { /* mixture prior */
		double sum; int k; double sub[10], muS[50]; 
		/* initialize */
		sum = .0;  k = design0->number_of_element;
		for (i=0; i< MIX_K; i++) sub[i] = .0; 
		for (j=0; j< k; j++) muS[j] = .0;
		/* row sum */
		for (i=0; i< MIX_K; i++)  for (j=0; j < k; j++)
		  sub[i] += design0->mix_aS[i][j];
		/* mu_S */
		for (j=0; j< k; j++) {
		    for (i=0; i< MIX_K; i++)
		      muS[j] += design0->Sprior_weight[i] * 
			design0->mix_aS[i][j]/sub[i];
		    sum += muS[j];
		}
		for (j=0; j< k; j++)
		  design0->aE[j] = muS[j] * k/sum;
	    }
	    else { /* single prior */
		double sum = .0;
		for (i=0; i< design0->number_of_element; i++) 
		  sum += design0->aS[i];
		for (i=0; i< design0->number_of_element; i++) {
		    design0->aE[i] = 
		      design0->aS[i] * design0->number_of_element/sum;
		}
	    }
	    printf("\nThe flat prior a_E:");   
	    for (i=0; i< design0->number_of_element; i++)
	      printf("\na_E%d = %.4f", i+1, design0->aE[i]);
	    
	    printf("\n\n(1) Accept these parameters"
		   "\n(2) Re-enter the parameters"
		   "\n(3) Back to previous menu\n");
	    do {
		printf("\n(Please choose 1, 2, or 3)\n> ");
		k = get_an_integer();
	    } while ( k < 1 || k > 3);
	    if ( k == 2 ) menu(221); /* redo */
	    if ( k == 3 ) (MIX_K > 1)? menu(210): menu(211); /* back */
	    
	    for (temp=design0->event0->next; temp != NULL; temp=temp->next)
	      update_aSaE(temp); /* compute (aS,aE) for each events */
	    
	    if (Lastmenu == 502) menu(502); 
	    else menu(231);  /* --move on------*/
	}
	if (option == 2)  menu(222);  /* move on to enter aE */
	if (option == 3)  menu(223);  /* move on to enter (muE, W) */
    }/*-------------------------------menu(221)------------------------*/
    
    else if (which_menu == 222) {   /* enter aE manually */
	if (Phase2a != 0) printf("Please enter the %d Beta parameters.\n",
			   design0->number_of_element );
        else printf("Please enter the %d Dirichlet parameters.\n",
		    design0->number_of_element );

        for (i = 0; i < design0->number_of_element; i++) {
            printf("a_E%d = ",i+1);
            value = get_a_double(0e0, 9999.);
	    if ((int)value == -2) menu(221); /* jump back */
            if ((int)value == -1) i = (i == 0) ? i-1 : i-2; 
            else
	      design0->aE[i] = fabs(value); 
	}

        printf("\nYou have entered :");
        for (i=0; i < design0->number_of_element ;i++) 
	    printf("\na_E%d = %.4f", i+1, design0->aE[i]);

        printf("\n\nPlease select from the following:\n"
	       "(1) Back to previous menu\n"
	       "(2) Accept these parameters\n"
	       "(3) Re-enter the parameters\n");
	do {
	    printf("\n(Please choose 1, 2, or 3)\n> ");
	    option = get_an_integer();
	} while (option < 1 || option > 3);
        if (option == 1)  menu(221); /* back */ 
	else if (option == 3)  menu(222); /* redo */
	else if (option == 2)  { 
	    for (temp=design0->event0->next; temp != NULL; temp=temp->next)
	      update_aSaE(temp); /* compute (aS,aE) for each events */
	    if ( Lastmenu == 502 ) menu(502); /* move on */
	    else menu(231); /* move on */
	}
    }/*---------------------------------------------menu(222)---------*/
    
    /* reparameterization of theta_E */   /* fix it later */
    else if (which_menu == 223) { 
        printf("Please enter the prior means.\n");
       	for (i=0; i < design0->number_of_element - 1 ;i++) 
	  design0->muE[i] = 0e0;
	
	sum = 1e0;
	for (i=0; i < design0->number_of_element - 1; i++) {
	    if (sum == 0e0) break;
            printf("muE%d = ",i+1);
            value = get_a_double(0e0, sum);
	    if (value < 0e0 || value > sum) {
		printf("\nMust be between 0 and %.3lf. Try again.\n", sum);
		--i;
		continue; 
	    }
	    if ( value >= 0e0 && value <= sum) { /* legitimate */
		design0->muE[i] = value;
		sum -= value;
	    }
	}
	design0->muE[design0->number_of_element -1] = sum;

        printf("\n\nYou have entered :");
	for (i=0; i < design0->number_of_element ;i++)  {
	    printf("\n\tmuE%d = %.4f", i+1, design0->muE[i]);
        }
	printf("\n(1) Back to previous menu."
	       "\n(2) Accept these prior means"
	       "\n(3) Re-enter the means\n");
	do {
	    printf("\n(Please choose 1, 2, or 3)\n> ");
	    option = get_an_integer();
	} while (option < 1 || option > 3);
	if (option == 1) menu(221); /* back */
	else if (option == 2) menu(224); /* move on */
	else if (option == 3) menu(223); /* redo */
    } /*----------------menu(223)--------------------------------------*/


    else if (which_menu == 224) { /* (mu, W) to aE */	
	printf("\n\nSelect which compound event will correspond to the\n"
	       "dispersion parameter:\n");
	i = 1;
	for (temp = design0->event0->next; temp != NULL; temp = temp->next){
	    printf("(%d) %s\n", i, temp->name);
	    ++i;
	}
	assert(i-1 == design0->number_of_event); /* check point */
	printf("> ");
	option = get_an_integer();

	if (option >= 1 && option <= design0->number_of_event) {
	    get_event(option, design0);
	}else {
	    printf("please select between 1 and %d\n", i-1);
	    menu(224);
	}	
	mm = 0e0;
	for (i=0; i<design0->number_of_element; i++)
	  if (design0->current_event->definition[i] == 1)
	    mm += design0->muE[i];
	/* mm = (mm < 1-mm)? mm : (1-mm);  */
	mm = 2 * Min(mm, 1-mm);
	
	printf("\n\nEnter W = the prior interval width for Pr[%s]\n",
	       design0->current_event->name);
	printf("(max = %.4f): > ", mm);

	value = get_a_double(0e0, mm);
	width = value;

	printf("\nEnter the Prior Interval Coverage Probability: > ");	
	value = get_a_double(0e0, 1e0);
		
	coverprob = value;
	printf("\nYou have entered:"
	       "\nCompound Event corresponding to the dispersion parameter:"
	       " \"%s\"\n", design0->current_event->name);
	printf("Prior Interval Width = %.4f", width);
	printf("\nPrior Interval Coverage Probability = %.4f", coverprob);
	printf("\n\nPlease select from the following:\n"
	       "(1) Accept these values\n"
	       "(2) Re-specify values for dispersion parameter:\n");
	do {
	    printf("\n(Please choose 1 or 2)\n> ");
	    option = get_an_integer();
	    if (option == -2) menu(223); /* back */
	} while (option < 1 || option > 2);
	if (option == 2) menu(224); /* try again */
	else if (option == 1) 
	  getdir(design0, width, coverprob, 2); /* workhorse: (mu,W,p)->aE */
	      
	for (temp=design0->event0->next; temp != NULL; temp=temp->next)
	  update_aSaE(temp); 
	
	if ( Lastmenu == 502 ) menu(502);  /* move on */
	else  menu(231);
    }/*-----------------------------end of menu(224)-----------*/

    /* before we go to 231, update_aSaE() must be called for every event */
    else if (which_menu == 231) {
	printf("\n\n----------------------\n"
	       "Nmin Menu\n"
	       "----------------------\n\n"
	       "Nmin = Minimum sample size.\n\n"
	       "If you specify Nmin = 1, the stopping bounds begin as soon\n"
	       "as the probability criterion for that event is met.\n"
	       "If you specify Nmin > 1, such as Nmin = 10, then a stopping\n"
	       "rule such as \"stop if #(toxicities)/n >= 8/10\" will start\n"
	       "at >= 8/8, because at this point the trial is certain to stop"
	       " at n = 10.\n"); 	
	printf("\nPlease enter Nmin, the minimum number of patients: ");
	do {
	    printf("\n(Please type a positive number)\nNmin = ");
	    option = get_an_integer();
	    if (option == -2)  menu(221);   /* back */
	} while (option <= 0);
	printf("\nYou have entered Nmin = %d", option);
	do {
	    printf("\nConfirmed? (y/n) > ");
	    j = get_an_integer();
	} while (j != 0 && j != 1);
	if ( j == 0 )  menu(231);  /* redo */
	design0->Nmin = option;  
	if ( Lastmenu == 502 ) { 
	    if ( design0->Nmin >= design0->Nmax ) menu(232);
	    Old = 1;   menu(502); 
	} else  { Lastmenu = 231; menu(232); }
    }/*--------------------------------------menu(231)-------------*/

    else if (which_menu == 232) {  /* Nmax menu */
	printf("\n----------\nNmax Menu\n----------\n\n"
	       "For regular design:\n"
	       "Nmax = Maximum sample size.\n\n"
	       "For randomized design:\n"
	       "Nmax = Maximum sample size per arm\n\n"
	       "(1) Select an arbitrary Nmax\n"
	       "(2) Calculate Nmax so that a specific posterior\n"
	       "    reliability is achieved.\n" 
	       "Which way do you want to choose Nmax?\n");	
	do { 
	    printf("\n(Please choose 1 or 2)\n> ");
	    option = get_an_integer();	
	    if (option == -2)  menu(Lastmenu); /* back to 231 or 502 */
	} while (option < 1 || option > 2);
	if (option == 1)  menu(233); /* move on */
	if (option == 2)  menu(234); /* move on */
    }/*--------------------------------------menu(232)-------------*/
    
    else if (which_menu == 233) {    /* key in Nmax */
	do {
	    printf("\nPlease enter Nmax: ("
		   "make sure Nmax > Nmin = %d)\nNmax = ", design0->Nmin);
	    option = get_an_integer();
	    if ( option == -2 )  menu(232); /* back */
	} while ( option <= design0->Nmin );

	printf("\nYou have entered Nmax = %d", option);	
	do {
	  printf("\nConfirmed? (y/n) > ");
	  k = get_an_integer();
	} while (k != 1 && k != 0);
	if (k == NO) menu(233);  /* redo */
	/* to make design0->Nmax = Nmax, we must lengthen the outcome[] */
	else update_Nmax(design0, option);
	
	if ( Lastmenu == 502 ) menu(502);
	else menu(241);  /* move on to monitor menu */
    }/*---------------------- menu(233) ----------------------------*/


    else if (which_menu == 234) {  /* compute Nmax */
	printf("Select a compound event to calculate Nmax. We recommend\n"
	       "that you choose the compound event of primary interest.\n");

	print_event_list(design0); 
	printf("Your choice? > ");
	option = get_an_integer(); 	
	tot = design0->number_of_event + design0->number_of_cond_event;

	if (option >= 1 && option <= tot) { /* legitimate */
	    get_event(option, design0);
	    /* design->current_event is the chosen one */
	} else { 
	    printf("type a number between 1 and %d.\n", tot);
	    menu(234);
	}
	/* more remark when cond event is chosen */
	if ( option > design0->number_of_event && option <= tot) { 
	    /* cond event chosen */
	    printf("* Please note the following when selecting Nmax\n\n");
	    printf("You have chosen to monitor '%s' conditioned on '%s'.\n",
		   design0->current_event->seed->name,
		   design0->current_event->parent->name);
	    thetanum=0e0;
	    thetaden=0e0;
	    for (i=0; i < design0->number_of_element ; i++) { 
		thetaden += design0->aS[i];
		if (design0->current_event->definition[i] == 1) 
		  thetanum += design0->aS[i];
	    }
	    /* check point */
	    prcevent = (thetanum/thetaden) + 
	      Max(design0->current_event->parent->deltaL, 
		  design0->current_event->parent->deltaU);
	    /* need to check with peter for this */
	    printf("Thus, you should set Nmax large enough so that a\n"
		   "sufficient number of %s's will occur to allow\n",
		   design0->current_event->parent->name);
	    printf("a reasonable number of '%s'.\n",
		   design0->current_event->seed->name);
	    printf("Since you are targeting Pr[%s] at %.2f,\n",
		   design0->current_event->parent->name, prcevent);
	    printf("if Nmax=100, then the expected number\n"
		   "of %s's would be %d, which in turn would be the\n",
		   design0->current_event->parent->name, 
		   (int)(100.0*prcevent+0.5));
	    printf("effective sample size for monitoring %s.\n\n",
		   design0->current_event->name);
	}	
	/* compute the Nmax */
	printf("\nEnter the posterior mean of Pr[%s]\n", 
	       design0->current_event->name);
	printf("to calculate Nmax: > ");
	
	muS = get_a_double(0e0, 1e0);
	
	printf("Enter the width for the posterior interval: > ");
	width = get_a_double(0e0, 1e0);
	
	printf("Enter the coverage probability: > ");
	coverprob = get_a_double(0e0, 1e0);
	
	nmax = compute_Nmax(design0->current_event, muS, width, coverprob); 
		
	if (nmax < design0->Nmin) { 
	    printf("The Nmax(= %d) is smaller than Nmin(= %d),\n",
		   nmax, design0->Nmin);
	    printf("you need to re-specify the width or cover prob or\n"
		   "choose a Nmax of your own.\n");
	    menu(232); /* back */
	}

	printf("\nCalculated Nmax = %d\n", nmax);
	printf("\nBased on this Nmax:\n");
	temp = design0->current_event;
	prcevent = muS;
	printf("The expected number of event %s is %d.\n",
	       design0->current_event->name, (int)(nmax * prcevent + 0.5));
	/*  printf("nmax = %d\nprcevent = %.3f\n", nmax, prcevent);*/

	printf("\n(1) Accept this Nmax\n"
	       "(2) Re-compute/Re-enter Nmax:\n");
	do {
	    printf("\n(Please choose 1 or 2)\n> ");
	    option = get_an_integer();
	} while (option < 1 || option > 2);
	if (option == 1) {
	    update_Nmax(design0, nmax); 
	    if ( Lastmenu == 502 ) menu(502); /* move on */
	    else menu(241); 
	}
	else menu(232); /* back */
    }/*----------------------------------------------menu(234)---------*/
    

    else if (which_menu == 241) {  /* monitoring method */
	printf("\n--------------------------\n"
	       "Outcome Monitoring Methods\n"
	       "--------------------------\n"
	       "Choose one of the following two methods for monitoring\n"
	       "patient outcomes during the trial.\n\n"
	       "(1) By Cohort:\n"
	       "----------------\n"
	       "    Your Bayesian stopping criteria will be applied\n"
	       "    after the outcomes have been observed for patients\n"
	       "    in each cohort of size c, where you will specify\n"
	       "    an integer value of c.\n"
	       "    \"Continuous Monitoring\" corresponds to c = 1.\n\n"
	       
	       "(2) Periodic Monitoring:\n"
	       "--------------------------\n"
	       "    Your Bayesian stopping criteria will be applied\n"
	       "    based on the available patient outcome data after\n"
	       "    each fixed time period t, that is at times\n"
	       "    t, 2t, 3t,..., etc, where you will specify the fixed\n"
	      "    period t, as well as the accrual rate and time units.\n\n");
	do {
	    printf("\nWhich would you like ? (choose 1 or 2) \n> ");
	    option = get_an_integer(); 
	    if (option == -2)  
	      menu( (Lastmenu == 502)? 502 : 231 ); /* back */
	} while (option != 1 && option != 2);
	if (option == 1) {
	    design0->monitor_method = 1;
	    menu(242); /* input cohort size  */
	}
	else if (option == 2) {
	    design0->monitor_method = 2;
	    menu(243);  /* poisson monitoring */
	}	
    }/*---------------------- menu(241) ----------------------------*/
    
    else if (which_menu == 242) { /* input cohort size */
	printf("You have chosen to monitor the trial by cohort.\n"
	       "Specify the cohort size c: ");
	do {
	    printf("\n(Please choose a positive number)\nc = ");
	    option = get_an_integer();
	    if (option == -2)  menu(241); /* back */
	} while (option <= 0);
	if (option >= 1) { /* cohort_size = option; */
	    design0->cohort_size = option;
	    if (Lastmenu == 502) menu(502); 
	    else menu(311);  /* move on to boundary business */
	}
    }/*---------------------End of menu(242) ---------------------*/

/* poisson monitoring */
    else if (which_menu == 243) {  /* poisson accrual rate */
	printf("You have chosen to monitor the trial by time.\n"
	       "This method requires accrual rate and monitoring time.\n");
	do {
	    printf("The accrual rate is: (must be positive) > ");
	    value = get_a_double(0e0, 999.9);
	} while (value <= 0e0);
	printf("\nYou have entered: accrual rate = %.2lf", value);
	do { printf("\nConfirmed? (y/n) > ");
	     j = get_an_integer();
	 } while ( j != 0 && j != 1 );
	if(j!=0) design0->accrual_rate = value;
	else  menu(243); /* redo */
	
	do {  /* poisson monitoring time */
	    printf("The monitoring period is: (must be positive) > ");
	    value = get_a_double(0e0, 999.9);
	} while (value <= 0e0);
	printf("\nYou have entered: monitor period = %.2lf", value);
	do { printf("\nConfirmed? (y/n) > ");
	     j = get_an_integer();
	 } while ( j != 1 && j != 0 );
	if(j!=0)  design0->monitor_period = value;
	else  menu(243);  /* redo */

	do {  /* response window */
	    printf("The response window is: (must be >= 0) > ");
	    value = get_a_double(0e0, 99e0);
	} while ( value < 0e0 );
	printf("\nYou have entered: response window = %.2lf", value);
	do { printf("\nConfirmed? (y/n) > ");
	     j = get_an_integer();
	 } while ( j != 1 && j != 0 );
	if(j==1)  design0->response_window = fabs(value);
	else  menu(243);  /* redo */
	/* move on */
	if (Lastmenu == 502) menu(502);
	else menu(311); 
    }/*---------------------end of menu(243) ---------------------*/


/* define events */ /* check with old menu(5) */
    else if (which_menu == 301) { /* define new event */
	printf("\n--------------------------\n"
	       "Define Compound Events\n"
	       "--------------------------\n"
	       "PLEASE Note: 	You must specify all events which you\n"
	       "wish to monitor, or which will be needed to define conditional\n"
	       "probabilities, e.g. if you wish to monitor A|B, then you must specify\n"
	       "both A and B.  For simplicity, all such events will be referred\n"
	       "to as 'Compound Events'.  Note that an elementary event of\n"
	       "interest may be one of your 'compound events'.\n\n");
	menu(302);
    }/*------------------------------------------------end of menu(301)--*/

    else if (which_menu == 302) {  /* naming */ 
	/* debug later : should allocate memory once use name an event */
	/* global index showing current event : Current_Event */
        temp= design0->current_event;
	printf("For Compound Event (%d):\n", 
	       design0->number_of_event+1);
	printf("Please enter a name for this compound event: > ");
	scanf("%s", word);
	if (strcmp(word, "back") == 0) { 
	    if (design0->number_of_event == 0) menu(Lastmenu); /* 202 or 502 */
	    else  menu(305);
	   }
	if (strcmp(word, "quit") == 0 || strcmp(word, "exit") == 0) {
	    printf("Are you sure? (plesase type 'yes' or 'no')\n> ");
	    scanf("%s", buf);
	    if ( strcmp(buf, "yes") == 0 ) exit(0);
	    else menu(302);
	}
	/* name checking */
	for (temp = design0->event0->next; temp != NULL; temp = temp->next) {
	    if (strcmp(word, temp->name) == 0) {
		printf("\nThis event already exist. Try again.\n");
		menu(302);
	    }
	}/*----end of name checking--------------------*/
	
	/* event type */
	printf("The type of event: \"%s\":\n", word);
	printf("(1) Efficacy\n(2) Adverse\n(3) Other\n> ");
	
	option = get_an_integer();
	if (option == -2) {
	    if (design0->number_of_event == 0) menu(Lastmenu); /* 202 or 502 */
	    else  menu(305);
	}
	type = (option == 1)?  1 : (option == 2)?  0 : -1;
	
	temp = make_event(type, word, /*design0->Nmax*/ 100, 
			  design0->number_of_element, NULL, NULL, NULL,
			  0e0, 0e0, 0e0, 0e0);
	/* sprintf(temp->name, "%s",  word); */
	add_event(temp, design0);
	/* free(word); *//* do it at the end of menu() */
	
	design0->current_event = temp;
	menu(303);  /* move on to definition */
    }/*-----------------------------------------------end of menu(302)---*/
  
    else if (which_menu == 303) {  /* definition */	
	Event *comp;
	printf("Please enter the different elementary events you want"
	       "\nincluded in this compound event.  Please separate them"
	       "\nwith spaces and enter a \"0\" at the end to signify"
	       "\nyou are finished."
	       "\n\nFor example, if you want the compound event to be the"
	       "\nunion of A2 and A4, then enter \"2 4 0\" at the prompt.\n");
	do {
	    printf("\n> ");
	    index = get_an_integer();
	    if (index == 0) break;
	    if (index == -2 ) {
		remove_event(design0->current_event, design0);
		menu(302); /* back */
	    }
	    if (index >= 1 && index <= design0->number_of_element) {
		/* legitimate */
		design0->current_event->definition[index-1] = 1;
	    } else {
		printf("** Error ** : Invalid index. Try again.\n");
		continue;
	    } 
	} while (index != 0);
	/* check if identical event exists */
	temp = design0->current_event; 
	for(comp=design0->event0->next; comp!=NULL && comp != temp; 
	    comp=comp->next) {
	    for(i=0; i<design0->number_of_element; i++) {
		if(temp->definition[i] != comp->definition[i])
		  break; /* temp != comp */
	    }
	    if (i == design0->number_of_element) {/* temp == comp */
		printf("\n** Identical event '%s' exists. Please re-define"
		       " the event.\n", comp->name);
		remove_event(design0->current_event, design0);
		menu(302);
	    }
	}
	/* echo */
	printf("For Compound Event (%d) :\n", design0->number_of_event);
	printf("--------------------------\n");
	printf("Elementary Events included : { ");
	for (i = 0; i < design0->number_of_element; i++) {
	    if (design0->current_event->definition[i] == 1)
	      printf("A%d ", i+1);
	}	
	update_aSaE(design0->current_event); 
	/* do this after input aS,aE (before menu(231)) */	
	printf("}\n\n");	
	menu(305); /* move on */
    }/*----------------------------------------------end of menu(303)---*/
   
    
    else if (which_menu == 305) { 
	if (design0->number_of_event == 0) menu(301);
	printf("\n-------------------------\n"
	       "Compound Events Chosen:\n"
	       "-------------------------\n"
	       "Name: \t\tElementary Events Selected\n"
	       "------\t\t---------------------------\n");
	index = 0;
	for (temp = design0->event0->next; temp != NULL; temp= temp->next){
	    printf("(%d) %-8s\t ", ++index, temp->name);
	    for (i=0; i< design0->number_of_element; i++) {
		if (temp->definition[i]==1)  printf("A%d  ", i+1);
		else printf("-   ");
	    }
	    printf("\n");
	}
	assert(index == design0->number_of_event);
	printf("\n(1) Add new compound event.\n"
	         "(2) Choose one event to edit or remove.\n"
	         "(3) Finished specifying all the compound events.\n");
	do {
	    printf("\n(Please choose 1, 2, or 3)\n> ");
	    option = get_an_integer();
	    if (option == -2) menu((Lastmenu==502)? 502 : 302);
	} while(option < 1 || option > 3);
	if (option == 3)  {    /* move on */
	    Modified = YES;
	    if ( Lastmenu == 502 ) menu(502);
	    Lastmenu = 305; menu(210); 
	}       
	else if (option == 1) menu(302);
	else {
	    do {
		printf("Choose one event (index: 1 to %d)\n> ", index);
		k = get_an_integer();
		if (k == -2) menu(305);
	    } while (k < 1 || k > design0->number_of_event);
	    get_event(k, design0);
	    update_event(design0->current_event);
	    menu(305);
	}
    }/*----------------------------------------------end of menu(305)---*/
    
    else if (which_menu == 311) {  /* boundary specification */
	Event *curr;
	printf("\n------------------------\n"
	       "Boundary Specification:"
	       "\n------------------------\n");
	review_boundary_parameter(design0);
	tot = design0->number_of_event + design0->number_of_cond_event;
	if (tot < 1 ) { printf("No event.\n"); return; }
	else if (tot == 1) get_event(1, design0);
	else {
	    printf("\nChoose one event for boundary specification.");
	    do {
		printf("\n(Please choose event 1 to %d, or "
		       "type '0' (zero) if done.)\n> ", tot);
		index = get_an_integer();
		if (index == 0) menu(361);
	    } while ( index < 1 || index > tot );
	    get_event(index, design0);
	}
	curr =  design0->current_event;
	if ( curr->parent == NULL ) { /* compound event */
	    int op;
	    printf("\nMonitor event '%s':\n", curr->name);
	    printf("\nYou have selected event '%s' to be monitored.\n\n", 
		   curr->name);
	    printf("You can monitor it in two ways:\n");
	    printf("1) Unconditionally; \n\n"
		   "2) Conditionally:\n");
	    printf("   You may now specify another event D upon which\n"
		   "   the event '%s' is monitored.\n"
		   "   In order to monitor '%s' conditionally upon D,\n"
		   "   event '%s' must intersect event D.\n\n",
		   curr->name, curr->name, curr->name);
	    do {
		printf("\n(Please choose 1 or 2)\n> ");
		op = get_an_integer();
	    } while (op != 1 && op != 2);

	    if (op == 1) { /* un-conditionally */
		input_boundary_parameter(curr);
	    } else  {/* conditionally */
		menu(3322);/* define conditional event we'll check and
			      forbid redefining same cond event */
	    }
	}
	else { /* conditional event */
	    printf("\nMonitor event '%s' conditionally upon '%s':\n",
		   curr->seed->name, curr->parent->name);
	    input_boundary_parameter(curr);
	}
	menu(312);
    }/*----------------------------------------------end of menu(311)---*/
    
    else if (which_menu == 312) { /* review the boundary parameters */
	/* allow user to choose a specific event for editing */
	tot = design0->number_of_event + design0->number_of_cond_event;
	/* show the list of boundary parameter for every event */
	review_boundary_parameter(design0);	
	printf("\n(1) Accept current specification.\n"
	       "(2) Choose one event to edit the boundary parameters.\n");
	do {
	    printf("(Please choose 1 or 2)\n> ");
	    option = get_an_integer();
	} while(option != 1 && option != 2);
	if (option == 1) menu(361);/*  menu(331); */ /* move on */
	else if (option == 2) menu(311);
    }/*----------------------------------------------end of menu(312)---*/
    
    /* obsolete */
    /* define conditional event */
    else if (which_menu == 331) {  /* define conditional event */
	printf("\n-------------------\n"
	       "Conditioning Menu:\n"
	       "-------------------\n\n"
	       "For any compound event C you have selected, you may now\n"
	       "specify another event D opon which the event C is monitored.\n"
	       "In order to monitor C conditional on D,\n"
	       "event C must intersect event D.\n\n"
	       "(1) Specify conditional events.\n"
	       "(2) Skip this option.\n");
	do { 
	    printf("\n(Please choose 1 or 2)\n> ");
	    option = get_an_integer();
	    if (option == -2) 
	      (Lastmenu == 502)? menu(502) : menu(312); /* back */
	} while (option < 1 || option > 2);		
	if (option == 1)  menu(3321);
	else  menu(361);  /* move on */
    } /*----------------------------------------end of menu(331)------*/
    
    else if (which_menu == 3321) {   /* input A of (A|B) */
	printf("Select a compound event to be monitored conditionally:\n\n"
	       "Name: \t\tElementary Events Selected\n"
	       "------\t\t---------------------------");
	index = 0;
	for (temp = design0->event0->next; temp != NULL; temp= temp->next){
	    printf("\n(%d) %-8s\t ", ++index, temp->name);
	    for (i=0; i< design0->number_of_element; i++) 
	      if (temp->definition[i]==1)  printf("A%d  ", i+1);
	      else printf("-   ");
	}
	if (index == 1) {
	    if(get_event(1, design0) == FAIL) menu(312);
	    temp = design0->current_event;
	    menu(3322);
	}
	else {
	    do {
		printf("\n\n(Please choose 1 to %d)\n> ", index);
		option = get_an_integer();
		if (option == -2) menu(312); /* menu(331); */
	    } while (option < 1 || option > index );
	    
	    if ( get_event(option, design0) == SUCCEED ) {
		temp = design0->current_event; 
		printf("You have chosen event: '%s'\n", temp->name);
		menu(3322);
	    } 
	    else menu(3321);
	} 	
    } /*-------------------------------end of menu(3321)---*/

    else if (which_menu == 3322) {  /* input B of (A|B) */
	Event *curr = design0->current_event;
	
	printf("\n\n-------------------------------------\n"
	       "Monitor event '%s' conditionally:\n"
	       "-------------------------------------\n\n", curr->name);
 	printf("Select another event upon which '%s' " 
	       "will be conditioned:\n\n",  curr->name);
	printf("Name: \t\tElementary Events Selected\n"
	       "------\t\t---------------------------\n");
	index = 0;
	for (temp = design0->event0->next; temp != NULL; temp= temp->next){
	    printf("(%d) %-8s\t ", ++index, temp->name);
	    for (i=0; i< design0->number_of_element; i++) 
	      if (temp->definition[i]==1)  printf("A%d  ", i+1);
	      else printf("-   ");
	    printf("\n");
	}
    	do {
	    printf("\n(Please choose 1 to %d)\n> ", index);
	    k = get_an_integer();
	    if (k == -2) menu(312); /* menu(331); */
	} while ( k < 1 || k > index );

	if ( get_event(k, design0) == FAIL ) menu(3322);
	else { 
	    Event *prev, *newparent = design0->current_event; 
	    flag = 0; 
	    /* check if previously defined if yes, go specify it w/o
	       making a new cond event */
	    for (prev = newparent->child; prev != NULL; prev = prev->next) 
	      if (strcmp(prev->seed->name, curr->name) == 0) {
		  input_boundary_parameter(prev);
		  menu(311); /* move on w/o make_cond_event() */
	      }
	    /* make cond event: 'curr | newparent' */
	    make_conditional_event(curr, newparent, &flag);
	    if (flag == SUCCEED) {
		printf("\nYou have specified a conditional event: %s\n\n",
		       design0->current_event->name);
		input_boundary_parameter(design0->current_event);
		menu(311);
	    }
	    else  {  /* fail */
		printf("** Please try again.\n");
		if (Lastmenu == 502) menu(3321);
		else menu(311);
	    }
	}
    } /*----------------------------------------end of menu(3322)------*/

    else if (which_menu == 333 ) {
	/* print_event_list(design0); */
	review_boundary_parameter(design0);
	do {
	    printf("\n(1) Define another conditional event.\n"
		   "(2) Finished:\n> ");
	    k = get_an_integer();	
	} while(k != 1 && k != 2);

	if (k == 1) menu(3321);
	else if (k == 2 && Lastmenu == 502 ) 
	  menu(502);     /* back to modification menu */
	else menu(361);  /* move on to simulation */	
    }/*----------------------------------------end of menu(333)------*/
    
    else if (which_menu == 361) { /* major review before simulation */
      print_design_in_file(design0, &flag);
      if (flag==0) { printf("Error: cannot store the design.\n"); return; }
      printf("\n---------------------------\n"
	     "Boundary Computation Menu\n"
	     "---------------------------\n"
	       "(1) Save the Design, Compute and Save the Boundaries.\n"
	       "(2) Read in the Boundaries.\n"
	       "(3) Modify the design parameters.\n"
	       "Which do you want? ");
	do {
	    printf("\n(Please choose 1, 2, or 3)\n> ");
	    option = get_an_integer();
	    if (option == -2 ) menu(333); /* back */ 
	} while ( option < 1 || option > 3);
	if (option == 1 || option == 2) { 
	    if (option == 1) compute_design_boundary(design0);
	    else read_design_boundary(design0);
	    
	    print_boundary_in_file(design0);
	    print_design_in_file(design0, &flag);
	    if (0==flag) { 
		printf("Error: cannot store the design.\n"); return; }
	    /* kill the old simulation results to avaid confusion */  
	    sprintf(buf, "%s", design0->filename);
	    one = strcat(buf, ".simout1\0");
	    remove(one);
	    sprintf(buf, "%s", design0->filename);
	    two = strcat(buf, ".simout2\0");
	    remove(two);
	    menu(362);
	} 
	else if (option == 3) {
	    menu(502);  /* design modification menu */
   	}
    }/*----------------------------------------end of menu(361)------*/


    else if (which_menu == 362 ) { /* boundary display menu */
	printf("\n-----------------------\n"
	       "Boundary Display Menu\n"
	       "-----------------------\n\n"
	       "(1) Display the boundaries\n"
	       "(2) Skip: ");
	do {
	    printf("\n(Please choose 1 or 2)\n> ");
	    option = get_an_integer();
	    if (option == -2 ) menu(361);
	} while (option < 1 || option > 2);
	if (option == 2) menu(363);
	else  {
	    print_boundary_on_screen(design0);
	    menu(363);
	}
    }/*----------------------------------------end of menu(362)------*/

    else if ( which_menu == 363 ) {
	printf("\n-------------\n"
	       "Main Menu\n"
	       "-------------\n\n"
	       "(1) Compute/Review operating characteristics\n"
	       "(2) Modify design parameters\n"
	       "(3) Review the design\n"
	       "(4) Review the boundaries\n"
	       "(5) Run another design\n"
	       "(6) Exit the program\n");
	do {
	    printf("\n(Please choose 1 to 6)\n> ");
	    option = get_an_integer();
	    if ( option == -2 ) menu(361);   /* back */
	} while ( option < 1 || option > 7 );	
	if (option == 1) menu(401);  /* simulation */ 
	else if (option == 2) menu(502); 
	else if (option == 3) {
	    print_design_on_screen(design0);
	    menu(363);
   	}
	else if (option == 4) {
	    print_boundary_on_screen(design0); menu(363);
	}
	else {
	    printf("\n\nPlease see the following files :\n");
	    printf("design info     : %s\n",design0->filename);
	    printf("boundaries      : %s.bnds\n",design0->filename);
	    printf("general OC's    : %s.simout1\n",design0->filename);
	    printf("break-down table: %s.simout2\n",design0->filename);
	    printf("Randomized trial: %s.simout3\n\n",design0->filename);
	    
	    if (option == 5) menu(101);
	    else  exit(0);
	}
    }/*----------------------------------------end of menu(363)------*/

    /* simulation menu */
    else if (which_menu == 401 ) {  /* input true prob[] */	
	printf("\n--------------------------------------\n"
	       "Operating Characteristics Menu\n"
	       "--------------------------------------\n\n"
	       "(1) Run regular simulation.\n"
	       "(2) Run randomized-trial simulation.\n\n"

	       "(3) View previous simulation results.\n"
	       "(4) View the \"reason-for-stopping\" table.\n"
	       "(5) View the previous randomized trial results.\n"
	       "(6) View the boundaries.\n\n"

	       "(7) Return to the main menu.\n"
	       "(8) Run another design.\n" 
	       "(9) Exit the program.\n\n"); 
	do {
	    printf("Which do you want? (choose 1 to 9)\n> ");
	    option = get_an_integer();
	    if(option == -2) menu(Lastmenu);
	} while (option < 1 || option > 9);
	
	if (option == 7) menu(363);
	else if (option == 8 || option == 9) {
	    printf("\n\nPlease see the following files :\n");
	    printf("design info     : %s\n",design0->filename);
	    printf("boundaries      : %s.bnds\n",design0->filename);
	    printf("general OC's    : %s.simout1\n",design0->filename);
	    printf("break-down table: %s.simout2\n",design0->filename);
	    printf("Randomized trial: %s.simout3\n\n",design0->filename);
	    
	    if (option == 8) menu(101);
	    else  exit(0);
	}
	else if (option == 1) {    /* input true prob[] */
	    Randomized = 0; menu(402); 
	}
	else if (option == 2) { /* run randomized trial */
	    menu(404);  /* specify arms, criterion event, etc.  */	   
	}
	else if ( 3 <= option && option <= 6) {
	    sprintf(name,"%s",design0->filename);
	    if (option == 3) two = strcat(name, ".simout1\0");
	    else if (option == 4) two = strcat(name, ".simout2\0");
	    else if (option == 5) two = strcat(name, ".simout3\0");
	    else if (option == 6) two = strcat(name, ".bnds\0");
	    text = get_file(two); /* read file "two" to "text" */
	    if ( text != NULL ) {
		printf("\n\n%s\n\n", text);
		free(text);
	    } else
	      printf("\n** There is no previous simulation for current setup.\n");
	    menu(401);		
	}	    
    }/*----------------------------------------end of menu(401)------*/
    
    else if (which_menu == 402) {  /* input true prob[] */
      int nelem = design0->number_of_element;
      if (design0->Nprob > 0) {
	printf("(1) Rerun the simulation using previously specified "
	       "probability vector(s).\n"
	       "(2) Enter new probabality vector(s).\n");
	do {
	  printf("Please choose 1 or 2)\n> ");
	  option = get_an_integer();
	} while ( option != 1 && option != 2);
	if (option == 1) menu(403);
      }

      if(Randomized!=0) {
	printf("\nEnter %d-entry probability vectors for each arm", nelem);
      } else {
	printf("\nEnter %d-entry probability vectors.", nelem);
	printf(" (allow at most %d vectors)\n", MAXP);
	printf("Make sure the values are separated by spaces.\nWhen you "
	       "are finished, enter a \"-1\" on a line by itself.\n"
	       "E.g.  \tif there are 4 elementary outcomes and you wish"
	       "\n      \tto evaluate the design OC's at :"
	       "\n      \tp=(.15,.15,.30,.40) and "
	       "\n      \tp=(.20,.20,.30,.30),"
	       "\n      \tyou enter :"
	       "\n\".15 .15 .3 .4 (enter)\n.2 .2 .3 .3 (enter)\n-1 (enter)\"");
      }	
      printf("\n** Please make sure the sum of each vector equals 1.0 **\n");
      
      if ( Lastmenu != 403 )  design0->Nprob = 0; 
      value = 0e0; 
      while (value >= 0e0) {
	if (Randomized !=0) printf("P(E_%d): > ", 1+design0->Nprob);
	else printf("%d: > ", 1+design0->Nprob);
	for (i=0; i < design0->number_of_element ; i++) {
	  value = get_a_double(0e0, 1e0);
	  if (value < 0e0) break;
	  else  design0->trueprob[design0->Nprob][i] = value;
	}	
	if (i == design0->number_of_element ) ++design0->Nprob;  
	if ((Randomized!=0) && (design0->Nprob == Arms)) break;
      } 
      if (design0->Nprob == 0) { 
	printf("\n** Cannot run simulation without probability vector.\n"
	       "   Please input at least one probability vector.\n\n");
	menu(402);
      }	
      if ((Randomized!=0) && (design0->Nprob < Arms)) {
	printf("** Must specify p-vectors for all %d arms\n", Arms);
	menu(402);
      }
      Lastmenu = 402;
      menu(403); 	
    }/*----------------------------------------end of menu(402)------*/
    

    else if (which_menu == 403) {   /* review and run? */
	if(Randomized!=0) printf("\nThe true probability of each arm:\n  ");
	else printf("\nYour selected probability vectors are:\n  ");
      
      for (i=0; i < design0->number_of_element ; i++)
	  printf("\tp(A%d)",i+1);
      printf("\n");
      for (i=0; i < design0->number_of_element ; i++) 
	  printf("\t-----");
      printf("\n");
      for (i=0; i< design0->Nprob; i++) {
	  if (Randomized!=0) printf("P(E_%d)", i+1);
	  else printf("[%d]",i+1);
	  for (j=0; j < design0->number_of_element ; j++)
	      printf("\t%.3f", design0->trueprob[i][j]);
	  printf("\n");
      }
      printf("\n(1) Run the simulations based on these values\n"
	     "(2) Delete all vectors and start again\n");
      /* "(3) Edit a probability vector\n"); */
      if (Randomized == NO) {
	  printf("(3) Delete a probability vector\n"
		 "(4) Add more vectors\n"); 
      }
      printf("Which would you like? ");
      do {
	  if (Randomized == YES) printf("(Please choose 1 or 2)\n> ");
	  else printf("(Please choose 1, 2, 3, or 4)\n> ");
	  option = get_an_integer();
	  if (option == -2 ) menu(401);
      } while (option < 1 || option > ((Randomized == YES)? 2 : 4));
      
      if (option == 1) {	   
	  if (Randomized == NO) {  /* regular simulation */
	      simulation(design0);
	      sprintf(name,"%s",design0->filename);
	      two = strcat(name, ".simout1\0");
	      text = get_file(two); /* read file "two" to "text" */
	      if ( text != NULL ) {
		  printf("\n\n%s\n\n", text);
		  free(text);
	      }
	  } else {   /* run randomized trial */		
	      if (reassign == YES) {
		  printf("** The boundary will be extended up to "
			 "N = Nmax * Arms = %d\n", 
			 design0->Nprob * design0->Nmax);	
	      }
	      /* should not recompute boundary if rerun */
	      update_Nmax(design0, design0->Nprob * design0->Nmax);
	      if (reassign == YES) {
		  print_boundary_in_file(design0);
	      }
	      printf("** Running randomized trial (%s re-randomization)...\n",
		     (reassign == YES)? "with" : "without");
	      
	      randomized_trial(design0, &reassign, &Extended); 
	      update_Nmax(design0, design0->Nmax/design0->Nprob); 
	      
	      printf("\n\nRun another %d-arm randomized trial? ", 
		     design0->Nprob);
	      do {
		  printf("\n(y/n) > ");
		  k = get_an_integer();
	      } while (k != 0 && k != 1);
	      if (k == YES) menu(402); 
	  }
	  menu(401);
      }
      else if (option == 2) {  /* start all over again */
	  design0->Nprob = 0;
	  menu(402);
      } 
      else if (option == 3) {  /* delete one vector */
	  if (design0->Nprob > 1) {
	      printf("Select a p-vector to delete (1%s %d) :", 
		     (design0->Nprob > 2)? ",..., ":", ", design0->Nprob);
	      option = get_an_integer();
	      if ((option >= 1) && (option <= design0->Nprob)) { 
		  for (i=(option-1); i < design0->Nprob; i++)
		      for (j=0; j < design0->number_of_element ;j++) 	
			  design0->trueprob[i][j] = design0->trueprob[i+1][j]; 
		  --design0->Nprob;
	      }
	    menu(403);
	  }
	  else if (design0->Nprob == 1) {
	      --design0->Nprob;
	      menu(403);
	  }
      } 
      else if (option == 4) {  /* input another p[] */
	  Lastmenu = 403;
	  menu(402);
      }
    }/*----------------------------------------end of menu(403)------*/
    
    
    else if (which_menu == 404) { 
	printf("\n--------------------------------------------------\n"
	       "Randomized Trial Menu\n" 
	       "--------------------------------------------------\n\n"
	       "This portion of the program deals with phase II trials where"
	       "\n1) patients are randomized among K experimental treatment "
	       "arms E_1,..,E_K\n2) the model and early stopping rules "
	       "which you have specified are applied within each arm and\n"
	       "3) among the arms not terminated early, the single \"best\""
	       " treatment having largest (smallest) posterior mean prob(C)"
	       " is selected for efficacy (adverse) event C.\n");
	do {
	    printf("Please specify:  K = the number of arms. "
		   "(at most 10)\nK = ");
	    Arms = get_an_integer();		
	    if (Arms == -2) menu(401); /* back */
	} while ( Arms < 1 || Arms > 10 );	
	printf("Please specify one event C to be used for the selection "
	       "criterion\n\n");
	do {  /* choose criterion */
	    traverse_event_list(design0);
	    if(design0->current_event->type == 3) 
	      printf("Event type unknown, cannot be used as a criterion.\n");
	    if(design0->current_event == NULL)
	      printf("Must choose one criterion event.\n"); 
	} while (design0->current_event->type == 3 || 
		 design0->current_event == NULL);
	printf("Event chosen: %s\n", design0->current_event->name);
	printf("Event type: %s\n", 
	       (design0->current_event->type ==1)? "Efficacy": "Adverse");
	
	printf("\nIf an arm is terminated after n patients have been\n"
	       "treated (n < Nmax), you may either randomize the remaining\n"
	       "(Nmax - n) patients among the remaining arms, or not do so\n"
	       "and thus have a smaller total sample size.\n\n"
	       "1) Re-randomize patients\n"
	       "2) Do not re-randomized patients\n");
	do {    
	    printf("Which would you like? (1 or 2)\n> ");
	    j = get_an_integer();
	} while ( j != 1 && j != 2 );
	reassign = (j == 1)? 1 : 0;
	/* final confirmation */
	printf("\nYou have specified a randomized trial:\n"
	       "--------------------------------------------------\n"
	       "- %d arms\n",Arms);
	printf("- Criterion event: %s\n", design0->current_event->name);
	printf("- %s re-randomization\n",(reassign == YES)? "With":"Without");
	printf("- Sample size per arm: Nmin = %d, ", design0->Nmin);
	if (reassign == YES) 
	  printf("Nmax = %d x %d = %d\n", design0->Nmax, Arms,
		 Arms*design0->Nmax);
	else printf("Nmax = %d\n", design0->Nmax);
	printf("--------------------------------------------------\n");
	do { printf("\nConfirmed? (y/n) > ");
	     j = get_an_integer();
	 } while (j != 0 && j != 1);
	if (j == YES) {  Randomized = 1;  menu(402); }
	else { Randomized = 0; menu(401); }
    }/*----------------------------------------end of menu(404)------*/
   

    /* modify old design */
    else if (which_menu == 501) { 
	char temp[200];
	printf("\n--------------------------\n"  
	       "Retrieving Old Design\n"
	       "--------------------------\n"	  
	       "Please enter the name of the design:\n"
	       " (8 chars. max, no spaces) : ");	
	scanf("%s",word);
	
	if (strcmp(word,"back") == 0)  menu(1);
	/* name checking */
	text = get_file(word);
	if (text == NULL) {
	    printf("** Cannot find the file.\n"
		   "** Please check if the file name is correct.\n");
	    menu(501);
	} else if (!get_data(text, "Storage file for design: ", temp)) {
	    printf("** There is no design stored in this file.\n"
		   "** Please check if the file name is correct.\n");
	    menu(501);
	}
	j = retrieve_old_design(word, design0);
	if ( j == FAIL ) {
	    printf("\nCannot find the design \"%s\", try another name.\n",
		   word);
	    menu(501);
	} else if ( j == SUCCEED ) {
	    printf("** Retrieved design:\n\"%s\"\nsuccessfully.\n\n",
		   design0->filename); 
	    Old = 1;
	    if (Phase2a != 0) menu(601); /* phase IIA */
	    else menu(5011);
	}
    }/*----------------------------------------end of menu(501)------*/
    
    else if (which_menu == 5011) {
	printf("1) Review the design\n"
	       "2) Modify the design and overwrite the design with "
	       "the modification\n"
	       "3) Modify the design but store the modification "
	       "under a different name\n"
	       "4) Run simulation without modification\n");
	do {
	    printf("\nYour choice? (1, 2, 3, or 4)\n> ");
	    k = get_an_integer();
	} while ( k < 1 || k > 4 );
	
	if ( k == 1 ) { print_design_on_screen(design0); menu(5011); }
	else if ( k == 2 ) menu(502);
	else if ( k == 3 ) {
	    int flag;
	    printf("Please specify the new name of the modified design.\n");
	    copy_design(design0, &flag); 
	    if (flag ==0) { 
		printf("** Error in copying the design.\n");
		menu(5011);
	    }
	    /* else design0 = design1;  *//* check this later */
	    menu(502); 
	}
	else if (k == 4) menu(401); /* move on to simulation */

    }/*--------end of menu(5011)-------*/

    else if (which_menu == 502 ) {/* design modification menu *//* menu(31) */
	printf("\n--------------------------\n"
	       "Design Modification Menu\n"
	       "--------------------------\n"
	       "WARNING - if you make modifications to an existing file\n"
	       "          without changing the filename, then any\n"
	       "          information in that file will be lost.\n\n"
	       "You may modify any of the following for design:\n\"%s\"\n\n",
	       design0->filename);
	printf("(1)  Nmin\n"
	       "(2)  Nmax\n"
	       "(3)  Prior for Standard Rx\n"
	       "(4)  Prior for Experimental Rx\n"
	       "(5)  Compound Events\n"
	       "(6)  Boundary Parameters\n"
	       "(7)  Monitoring method\n"
	       "(8)  Save the modification and return to main menu.\n\n"
	       "Which would you like? ");
	do {
	    printf("(Please choose 1 to 8)\n> ");
	    option = get_an_integer(); 
	} while (option < 1 || option > 8);
	if (option == 8)  {
	    int flag;
	    compute_design_boundary(design0);
	    print_boundary_in_file(design0);
	    print_design_in_file(design0, &flag);
	    if (flag != 0) menu(363); /* back to main menu */
	    else { 
		printf("\n** Error in saving the modification.\n");
		exit(0);
	    }
	}
	/* a flag showing we're modifying old design. */
	if ((option >= 1) && ( option <= 7)) {
	    Lastmenu = 502; Old = 1; 
	}
	/* design */
	if (option == 1) menu(231);  
	else if (option == 2) menu(232);
	else if (option == 3) menu(210);
	else if (option == 4) menu(221);

	/* events */
	else if (option == 5) { /* compound event */
	    if (design0->number_of_event == 0) {
		printf("No compound event defined yet.\n"); 
		menu(502);
	    }
	    else menu(305);
	}
	else if (option == 6) menu(311); /* boundary */
	else if (option == 7) menu(241); /* monitoring */
	menu(363); /* back to main menu */
    }/*---------------------------------------end of menu(502)------*/

    else if (which_menu == 601) { /* phase IIA menu */
	printf("\n----------------------------\n"
	       "Phase IIA design menu\n"
	       "----------------------------\n\n"
	       "You are doing a Phase IIA design.\n"
	       "Please choose the stopping rule:\n"
	       "1) Pr[theta_E > p_Null | X, n] < pL  (Efficacy Event Criterion)\n"
	       "2) Pr[theta_E > p_Null | X, n] > pU  (Adverse Event Criterion)\n"
	       "where theta_E | (X, n) ~ Beta(aE + X, bE + n - X)\n"
	       "n in Nmin to Nmax.\n\n");
	do {
	    printf("Please choose one: (1 or 2)\n> ");
	    Phase2a = get_an_integer();
	} while (Phase2a != 1 && Phase2a != 2);
	
	printf("Please specify the design parameters:\n\n");
	printf("pNull = "); pNull = get_a_double(0e0, 1e0);
	if (Phase2a == 1)   printf("pL = ");
	if (Phase2a == 2)   printf("pU = "); 
	pp = get_a_double(0e0, 1e0);
	printf("aE = "); aE = get_a_double(0e0, 999.0);
	printf("bE = "); bE = get_a_double(0e0, 999.0);
	/* new */
	printf("Nmin = "); m = get_an_integer();
	printf("Nmax = "); n = get_an_integer();
	
	sprintf(name,"%s",design0->filename);
	two = strcat(name, ".simout1\0");
	fp = fopen(two, "a");
	if (fp == NULL) {
	    printf("** Error: cannot open file for storing phaseIIA result.\n");
	    exit(0);
	}
	do {
	    printf("True probability to simulate from: ");
	    pTrue = get_a_double(0e0, 1e0);
	      printf("------------------------------------------------------------------\n"
		   "Nmin = %d, Nmax = %d, Pr(true) = %.3f, aE = %.3f, bE = %.3f, ",
		   m, n, pTrue, aE, bE);
	    printf("\nIterations = %d\n", TRIALSIZE);
	    if (Phase2a == 1)
	      printf("pNull   pL    p(stop)  10  25  50  75  90 (trial size percentile)\n");
	    if (Phase2a == 2)
	      printf("pNull   pU    p(stop)  10  25  50  75  90 (trial size percentile)\n");
	      printf("------------------------------------------------------------------\n");
	     /* print overhead */
	    fprintf(fp, "------------------------------------------------------------------\n");
	    fprintf(fp,"Nmin = %d, Nmax = %d, Pr(true) = %.3f, aE = %.3f, bE = %.3f, ",
		    m,  n, pTrue, aE, bE);
	    fprintf(fp,"\nIterations = %d\n", TRIALSIZE);
	    if (Phase2a == 1) 
	      fprintf(fp, "pNull   pL    p(stop)  10  25  50  75  90 (trial size percentile)\n");
	    if (Phase2a == 2) 
	      fprintf(fp, "pNull   pU    p(stop)  10  25  50  75  90 (trial size percentile)\n");
	    fprintf(fp,"------------------------------------------------------------------\n");
	    /* phase2a(pTrue, pNull, pp, aE, bE, n, fp, Phase2a); */
	    phase2a2(pTrue, pNull, pp, aE, bE, m, n, fp, Phase2a);
	    fprintf(fp,"-------------------------------------------------------------\n\n");
	    printf("\nRun another simulation with different true probability?"
		   "(y/n) > ");
	    option = get_an_integer();
	} while (option == YES);
	fclose(fp);
	menu(602);
    }/*---------------------------end of menu(601)------*/
    
    else if (which_menu == 602) { 
	printf("(1) Run another simulation with different parameters.\n"
	       "(2) View the previous simulations result.\n"
	       "(3) Change the design setting.\n"
	       "(4) Run another design.\n"
	       "(5) Exit the program.\n"
	       "Which do you want? ");
	do {
	    printf("\n(Please choose 1 to 5)\n> ");
	    option = get_an_integer();
	} while (option < 1 || option > 5);
	if (option == 1) menu(601);
	else if ( option == 2) {   
	    sprintf(name,"%s",design0->filename);
	    two = strcat(name, ".simout1\0");
	    text = get_file(two);
		
	    if ( text != NULL ) {
		printf("\n\n%s\n\n", text);
		free(text);
	    }
	    if ( text == NULL ) 
	      printf("\n\nThere are no previous simulations...\n");
	    menu(602);		
	} 
	else if (option == 3) menu(202);
	else if (option == 4 || option == 5) {
	    sprintf(name,"%s",design0->filename);
	    two = strcat(name, ".simout1\0");
	    printf("\n\nThe result is stored in file:\n\"%s\"\n", two);
	    
	    if (option == 4)  menu(101);
	    else  exit(0);
	}
	else menu(602);
    }/*---end of menu(602)---*/
    free(word);
/*--------------------------------------------end of menu()------*/
}

/* for modifying old design */
/* new max, must recompute boundary */
void update_Nmax(Design *design, int newmax)
{
    Event *comp, *cond;  int i;
    /*    Nmax = newmax; */ /* global nuisance */
    if (newmax < design->Nmin) {
	printf("New Nmax < Nmin in update_Nmax()\n");
	return;
    }
    if (newmax > design->Nmax) {
	for (comp = design->event0->next; comp != NULL; comp = comp->next){
	    /* compound events */
	    comp->Nmax = newmax;
	    free(comp->lowerbound);  free(comp->upperbound);
	    comp->lowerbound = (int*) malloc((newmax+1) * sizeof(int));
	    comp->upperbound = (int*) malloc((newmax+1) * sizeof(int));
	    for (i=0; i <= newmax; i++) {  
		comp->lowerbound[i] = -1;
		comp->upperbound[i] = i+1;
	    }
	    compute_event_upperbound(comp);
	    compute_event_lowerbound(comp);
	    
	    /* conditional events */
	    for (cond = comp->child; cond != NULL; cond = cond->next) {
		cond->Nmax = newmax;
		free(cond->lowerbound); 
		free(cond->upperbound);
		cond->lowerbound = (int*) malloc((newmax+1) * sizeof(int));
		cond->upperbound = (int*) malloc((newmax+1) * sizeof(int));
		for (i=0; i <= newmax; i++) { 
		    cond->lowerbound[i]= -1; /* the default boundary */
		    cond->upperbound[i]=i+1; /* i = number of patients */
		}
		compute_event_upperbound(cond); 
		compute_event_lowerbound(cond);
	    }
	}
    }
    else if (newmax == design->Nmax) return;

    else if (newmax < design->Nmax) {
	for (comp = design->event0->next; comp != NULL; comp = comp->next){
	    comp->Nmax = newmax;
	    for (cond = comp->child; cond != NULL; cond = cond->next) 
	      cond->Nmax = newmax;
	}
    }
    design->Nmax = newmax;
/*----------------------------------------------end of update_Nmax() ---*/
}

/* update aS, aE after the definition is updated */
void update_aSaE(Event *event)
{
    int i, j;  int K = event->design->Sprior_type;
    if ( K > 1 ) { /* mixture prior */
	for (j = 0; j < K; j++) {
	    event->mix_aS[j] = event->mix_bS[j] = .0;
	    for (i=0; i< event->number_of_element; i++) {
		if (event->definition[i]==1) 
		  event->mix_aS[j] += event->design->mix_aS[j][i];
		
		if (event->parent != NULL) {  /* conditional event */
		    if (event->definition[i] == 0 && 
		       event->parent->definition[i]==1) {
			event->mix_bS[j] += event->design->mix_aS[j][i];
		    }
		}
		else 
		  if (event->definition[i] == 0) 
		    event->mix_bS[j] += event->design->mix_aS[j][i];
	    } 
	}
	event->aE = 0e0;  event->bE = 0e0;	
	for (i=0; i< event->number_of_element; i++) {
	    if (event->definition[i]==1) 
	      event->aE += event->design->aE[i];
	    
	    if (event->parent != NULL) {  /* conditional event */
		if (event->definition[i] == 0 && 
		    event->parent->definition[i]==1) {
		    event->bE += event->design->aE[i];
		}
	   } 
	    else 
	      if (event->definition[i] == 0) 
		event->bE += event->design->aE[i];	    
	}	 
    }
    else {  /* single prior */
	event->aS = 0e0;  event->bS = 0e0;
	event->aE = 0e0;  event->bE = 0e0;
	
	for (i=0; i< event->number_of_element; i++) {
	    if (event->definition[i]==1) {
		event->aS += event->design->aS[i];
		event->aE += event->design->aE[i];
	    }
	    if (event->parent != NULL) {  /* conditional event */
		if (event->definition[i] == 0 && 
		   event->parent->definition[i]==1) {
		    event->bS += event->design->aS[i];
		    event->bE += event->design->aE[i];
		}
	    }
	    else {
		if (event->definition[i] == 0) {
		    event->bS += event->design->aS[i];
		    event->bE += event->design->aE[i];
		}
	    }
	}
    }
/*----------------------------------end of update_aSaE()--------------*/
}


/* flag: 1 = success, 0 = fail */
void rename_design(Design *design, int *flag)
{
    int move, option; FILE *fp; char buf[200], buf2[200];
    char *word = (char*) malloc(150 * sizeof(char));  
    printf("\n----------------------------\n"
	   "Rename old design\n"
	   "----------------------------\n"	   
	   "If you rename the old design, four files will be renamed:\n"
	   "\"oldname\" --> \"newname\"\n"
	   "\"oldname.bnds\" --> \"newname.bnds\"\n"    
	   "\"oldname.simout1\" --> \"newname.simout1\"\n"
	   "\"oldname.simout2\" --> \"newname.simout2\"\n\n");
    do {
	printf("\nSelect a new name for design: \"%s\"\n",design->filename);
	printf("(Please leave no spaces): > ");    	
	scanf("%s", word);
	
	if ( (fp = fopen(word,"r")) != NULL ) {
	    fclose(fp);
	    printf("\nThe name \"%s\" already exists.\n", word);
	    do {
		printf("1) Overwrite the old file\n"
		       "2) Select another name\n"
		       "3) Skip\n"	
		       "Your choice? ");		       
		option = get_an_integer();
		if ( option == 1 ) move = 0;  /* move on */
		else if ( option == 2 ) move = 1;  /* another name */
		else if ( option == 3 ) return;  /* quit */
		else printf("Please type \"1\", \"2\", or \"3\"\n");
	    } while ( option != 1 && option!= 2 && option != 3 );
	}
	/* check the path */
	while ((fp = fopen(word, "a")) == NULL ) {
	    fclose(fp);
	    printf("** Can not write to file:\n   \"%s\".\n", word);
	    printf("** Please check if the path is correct.\n\n");
	    continue;
	}
	fclose(fp); 	
	move = 0; /* move on */
    } while (move == 1);
    
    do {
	char choice[10];
	printf("Confirmed? (Please type 'yes' or 'no') > ");
	scanf("%s", choice);
	if ( strcmp(choice, "yes") == 0 ) option = 1;
	else if ( strcmp(choice, "no") == 0 ) option = 0;
	else option = -99;
	if (option == 0) return;
	else if (option == 1) {
	    rename(design->filename, word);
	    sprintf(buf, "%s.bnds", design->filename);
	    sprintf(buf2, "%s.bnds", word);
	    rename(buf, buf2);
	    
	    sprintf(buf, "%s.simout1", design->filename);
	    sprintf(buf2, "%s.simout1", word);
	    rename(buf, buf2);
	    
	    sprintf(buf, "%s.simout2", design->filename);
	    sprintf(buf2, "%s.simout2", word);
	    rename(buf, buf2);
	    
	    sprintf(buf, "%s", design->filename);
	    sprintf(design->filename, "%s", word);
	    print_design_in_file(design, flag);
	    if (flag == 0) {
		sprintf(design->filename, "%s", buf);
		*flag = 0;
		return;
	    } else printf("Rename design:\n\"%s\"\n", buf),
	    printf("to design:\n\"%s\"\nis complete.\n",design->filename);
	}
    } while ( option != 1 && option != 0 );
    *flag = 1;     free(word);
/*-----------------------------------------end of rename_design()----*/
}

void copy_design(Design *design, int *flag)
{    
    int move, option; FILE *fp; char buf[200]; 
    char *word = (char*) malloc(150 * sizeof(char));  
    printf("\n----------------------------\n"
	   "Copy old design\n"
	   "----------------------------\n"
	   "If you rename the old design, four files will be renamed:\n"
	   "\"oldname\" --> \"newname\"\n"
	   "\"oldname.bnds\" --> \"newname.bnds\"\n"
	   "\"oldname.simout1\" --> \"newname.simout1\"\n"
	   "\"oldname.simout2\" --> \"newname.simout2\"\n\n");
    move = 1;
    while (move) {
	printf("\nSelect a name for the copy of the design:\n"
	       "\"%s\"\n",design->filename);
	printf("\n(Please leave no spaces):\n> ");    	
	scanf("%s", word);
	/* check if the file exists */
	if ( (fp = fopen(word,"r")) != NULL ) {
	    fclose(fp);
	    printf("\nThe file:\n\"%s\" already exists.\n", word);	    
	    printf("1) Overwrite the old file\n"
		   "2) Select another name\n"
		   "3) Skip\n\n");
	    do {
		printf("Your choice? (1, 2,or 3)\n> ");
		option = get_an_integer();
	    } while (option < 1 || option > 3);
	    if ( option == 1 ) move = 0;  /* go on to check path */
	    if ( option == 2 ) continue;  /* another name */
	    if ( option == 3 ) return;    /* quit */
	}
	/* check the path */
	fp = fopen(word, "a");
	if (!fp) {
	    printf("** Can not write to file:\n   \"%s\".\n", word);
	    printf("** Please check if the path is correct.\n\n");
	    continue;
	}
	fclose(fp);
	move = 0;
    }
    printf("** Make a copy of design:\n   %s\n", design->filename);
    printf("** Save the copy in file:\n   %s\n", word);
    strcpy(buf, design0->filename);
    strcpy(design0->filename, word);
    print_design_in_file(design0, flag);
    if (*flag) {
	printf("** Copy design:\n   \"%s\"\nto design:\n", buf);
	printf("   \"%s\"\nis complete.\n",  design->filename);	
    }
    free(word);
/*----------------------------end of copy_design()-------------------*/
}


/* must update all related cond events, too */
void update_event(Event *event)
{
    char buf[200]; int i, k, option; Event *temp;
    if (event == NULL) {
	printf("cannot edit null event.\n"); 	return; }
    do {
	printf("\nYou have chosen event:\"%s\".\n", event->name);
	printf("1) Remove this event\n"
	       "2) Rename this event\n"
	       "3) Change the elementary events selected\n"
	       "4) Skip\n\n"
	       "(Please choose 1, 2, 3, or 4):\n> ");
	option = get_an_integer();
    } while (option != 1 && option != 2 && option != 3 && option != 4);

    if (option == 4) return;
    else if (option == 1) {  /* remove */
	remove_event(event, event->design);
	/* takes care of related cond events, too*/
	return;
    }	
    else if (option == 2) {  /* rename */
	printf("New name: > "); scanf("%s", buf);
	/* name checking */
	for (temp=design0->event0->next; temp != NULL;temp=temp->next) {
	    if (strcmp(buf, temp->name) == 0) {
		printf("\n** This event already exist. Try another name.\n");
		update_event(event);
	    }
	}
	strcpy(event->name, buf);
    }
    else if (option == 3) {   /* definition */
	for (i=0; i< design0->number_of_element; i++)
	  event->definition[i] = 0; /* reset */
	
	printf("Please enter the different elementary events you want"
	       "\nincluded in this compound event.  Please separate them"
	       "\nwith spaces and enter a \"0\" at the end to signify"
	       "\nyou are finished.\n\n"
	       "For example, if you want the compound event to be the\n"
	       "union of A2 and A4, then enter \"2 4 0\" at the prompt.\n");
	k = 1;
	while ((k != 0) && (k!=-2)) {
	    printf("\n> ");
	    k = get_an_integer();
	    if (k >= 1 && k <= design0->number_of_element) {
		/* legitimate */
		for (i = 0; i < design0->number_of_element; i++)
		  event->definition[k-1] = 1;
	    } else {
		/* printf("** Error ** : Invalid option. Try again.\n"); */
		continue;
	    } 
	}
	/* echo */
	printf("For Compound Event \"%s\":\n", event->name);
	printf("--------------------------\n"
	       "Elementary Events included : ( ");
	for (i = 0; i < design0->number_of_element; i++) {
	    if (event->definition[i] == 1)
	      printf("A%d ", i+1);
	}
	printf(")\n\n"); 
	update_aSaE(event);  /* update aS and aE */
    }
/*----------------------------------end of update_event()------------*/
}


void plot_menu(Design *design)
{ 
    double aS, bS, aE, bE, lo, up; int n, x;
    char buf[200];
    printf("\n--------------------\n"
	   "Plot Menu\n"
	   "--------------------\n"
	   "We can generate data for the plot of delta vs"
	   "Lambda(delta) = Prob(eta_S + delta < eta_E | X)\n\n"
	   
	   "etaS: standard probability of a binary event of interest.\n"
	   "etaE: experimental probability of a binary event of interest.\n"
	   "X: total number of response.\n"
	   "N: total number of patients.\n"    
	   "1) Event of interest:\n");
    choose_event(design);
    aS = design->current_event->aS; bS = design->current_event->bS;
    aE = design->current_event->aE; bE = design->current_event->bE;
    printf("\nPrior:\n");
    printf("etaS ~ beta(%.3f, %.3f)\n", aS, bS);
    printf( "etaE ~ beta(%.3f, %.3f)\n", aE, bE);
     printf("prior mean of etaS = %.3f\n", aS/(aS+bS));
     printf("prior mean of etaE = %.3f\n", aE/(aE+bE));
     printf("2) Total number of patients: N = ");
    n = get_an_integer();
    printf("3) Total number of response: X = "); 
    x = get_an_integer();
    
    if (n <=0 || x <=0 || x > n) {
	printf("wrong entry. try again.\n"); 
	plot_menu(design); }
    
    printf("You have chosen: X = %d, N = %d\n\n", x, n);
    printf("Posterior:\n");
    printf("etaS | X ~ beta(%.3f, %.3f)\n", aS+x, bS+n-x);
    printf("etaE | X ~ beta(%.3f, %.3f)\n", aE+x, bE+n-x);
    printf("posterior mean of etaS = %.3f\n", (aS+x)/(aS+bS+n));
    printf("posterior mean of etaE = %.3f\n", (aE+x)/(aE+bE+n));
    
    printf("Range of delta:\n");
    printf("min(delta) = "); lo = get_a_double(-1e0, 9999.);
    printf("max(delta) = "); up = get_a_double(-1e0, 9999.);

    printf("Generate data of delta in (%.4f, %.4f) and\n", lo, up);
    printf("Lambda(delta) = Prob(etaS + delta < etaE | X)\n"
	   "Save the data in file:(file name no longer than 50) > ");
    scanf("%s", buf);
    plot_func(lo,up, x,n, design->current_event, Lambda4, buf); 
    menu(363);
/*-------------------------------------end of plot_menu()------------*/
}

/* this function is buggy, don't use this function
   use phase2a_lowerbound() instead  */
int *phase2a_lowerbound_old(double pNull, double pL, double a, double b, int Nmax)
{ 
    /* return the stopping bounds of Pr(theta > pNull | m out of N) < pL
       m = 0,1,2,.... where theta |(m out of N) ~ beta(a + m, b + N - m); 
       bound[i] = m is boundary i/m
       */
    int *bound;  int i, j, m;
    int *temp = (int*) calloc(Nmax+1, sizeof(int));
    if (!temp) {
	printf("** Error: memory allocation fails in phase IIA.\n");
	exit(1);
    }
    m = 1; i = 0;
    while ( i < m ) {
  	while( Lambda3(i, m, a, b, pNull) >= pL ) 
	  ++m;
	if (m < Nmax) temp[i] = m;  /* boundary i/m */
	else break;
        ++i;
    }    
    bound = (int*) calloc(i+1, sizeof(int));
    if (!bound) {
	printf("** Error: memory allocation fails in phase IIA.\n");
	exit(1);
    }
    for (j=0; j<i; j++) bound[j] = temp[j];
    bound[i] = -1;  /* the end */
    free(temp);
    return bound;
}


int *phase2a_lowerbound(double pNull, double pL, double a, double b, int Nmax)
{ 
    /* return the stopping bounds of Pr(theta > pNull | m out of N) < pL
       m = 0,1,2,..,N. i.e. the smallest m which meets the criterion.
       where theta|(m/N) ~ beta(a + m, b + N - m); */
    /* bound[m] = i  ==> lowerbound i/m */
    int k, m;
    int *bound = (int*) malloc((Nmax+1) * sizeof(int));
    if (!bound) {
	printf("** Error: memory allocation fails in phase IIA.\n");
	exit(1);
    }
    bound[0] = -1;  k = 1;
    while( Lambda3(0, k, a, b, pNull) > pL ) { /* no lowerbound */
	bound[k] = -1;
	++k;
    }
    bound[k] = 0;  /* first lowerbound */

    for (m = k+1; m < Nmax; m++) {
	if ( Lambda3(bound[m-1] + 1, m, a, b, pNull) < pL )
	  bound[m] = bound[m-1] + 1;
	else bound[m] = bound[m-1];
    }  
    return bound;
/*----end of phase2a_lowerbound()-----*/
}


int *phase2a_upperbound(double pNull, double pU, double a, double b, int Nmax)
{ 
    /* return the stopping bounds of Pr(theta > pNull | m out of N) > pU
       m = 0,1,2,..,N. i.e. the smallest m which meets the criterion.
       where theta|(m/N) ~ beta(a + m, b + N - m); */
    /* bound[m] = i  ==> upperbound i/m */
    int k, m;
    int *bound = (int*) malloc((Nmax+1) * sizeof(int));
    if (!bound) {
	printf("** Error: memory allocation fails in phase IIA.\n");
	exit(1);
    }
    bound[0] = 99; k = 1;
    while( Lambda3(k, k, a, b, pNull) < pU ) { /* no upperbound */
	bound[k] = k + 99;
	++k;
    }
    bound[k] = k;  /* first upperbound */

    for (m = k+1; m < Nmax; m++) {
	if ( Lambda3(bound[m-1], m, a,b,pNull) > pU )
	  bound[m] = bound[m-1];
	else bound[m] = 1 + bound[m-1];
    }  
    return bound;
/*----end of phase2a_upperbound()-----*/
}


/* run simulation for phase IIA design */
/* type = 1: efficacy lower bound; 2: adverse upper bound */
/* this function is obsolete, use phase2a2() */
void phase2a(double trueprob, double pNull, double pp, 
	     double a, double b, int Nmax, FILE *fp, int type)
{
    double p_stop;  int quantile[5],  *bound; int out;
    int i, m, k, K, total_hit, result[TRIALSIZE]; double dice;
    char *st1, *temp;
      
     if (type == 1) {
	bound = phase2a_lowerbound(pNull, pp, a, b, Nmax);
	K = 0;
 	while( bound[K] > 0 ) ++K;  /* number of check points */
    	total_hit = 0;  
    	for (i=0; i< TRIALSIZE; i++) {
	    m = 0; out = 0;
	    for (k = 1; k < Nmax; k++) { /* generate outcome counts */
		dice = (double) genunf((float)0, (float)1);
		if ( dice < trueprob ) ++out;
			
		/* check lower bound */
		if (k == bound[m]) {
		    if (out <= m) { /* hit */
			result[i] = bound[m]; 
			++total_hit;  
			break;
		    }
		    ++m;
		}
	    }
	    if (m == K) result[i] = Nmax; /* complete the trial */
	}
    }
    if (type == 2) { /* adverse event */
	bound = phase2a_upperbound(pNull, pp, a, b, Nmax);
	total_hit = 0;
	for (i=0; i< TRIALSIZE; i++) {
	    out = 0;
	    for (k = 1; k < Nmax; k++) { /* generate outcome counts */
		dice = (double) genunf((float)0e0, (float)1e0);
		if ( dice < trueprob )  ++out;
		
		 /* check upper bound */
		if ( out >= bound[k] ) { /* hit */
		    result[i] = k; 
		    ++total_hit;  
		    break;
		}
	    }
	    if (k == Nmax ) result[i] = Nmax; /* complete the trial */
	}
    }
    /* result */
    p_stop = (double) total_hit / TRIALSIZE;    
    qsort(result, TRIALSIZE, sizeof(int), intcompare); 
    quantile[0] = result[(int)(TRIALSIZE* .10)];
    quantile[1] = result[(int)(TRIALSIZE* .25)]; 
    quantile[2] = result[(int)(TRIALSIZE* .50)];
    quantile[3] = result[(int)(TRIALSIZE* .75)];
    quantile[4] = result[(int)(TRIALSIZE* .90)];    
    /* print out the result */
    printf("%.3f %.3f  ", pNull, pp); fprintf(fp, "%.3f %.3f  ", pNull, pp);  
    st1 = (char*) calloc(150, sizeof(char));
    temp = (char*) calloc(20, sizeof(char));
    if (!st1 || !temp) {
	printf("Error: memory allocation fails in phase IIA.\n"); 
	exit(0);
    }
    if (type == 1) { /* print lower bounds */
	for (i = 0; i< K; i++) {
	    (void) sprintf(temp, "%d/%d, ", i, bound[i]);
	    st1 = strcat(st1, temp); 
	}	
	printf("%-30s ", st1);
	fprintf(fp, "%-30s ", st1);
    }
    if (type == 2) { /* print upper bounds */
	for (i=1; i< Nmax; i++) 
	  if (bound[i] != bound[i-1] && bound[i] <= i) {
	    (void) sprintf(temp, "%d/%d, ", i, bound[i]);
	    st1 = strcat(st1, temp);
	  }
	printf("%-30s ", st1);
	fprintf(fp, "%-30s ", st1);
    }
    printf("  %.3lf   ", p_stop);  fprintf(fp, "  %.3lf   ", p_stop);
    for (i = 0; i< 5; i++) {
	printf("%2d  ", quantile[i]);  fprintf(fp, "%2d  ", quantile[i]);
    }
    printf("\n");  fprintf(fp, "\n");
    free(bound); free(st1); free(temp);
/*---end of phase2a()-----*/
}


/* run simulation for phase IIA design */
/* type = 1: efficacy lower bound; 2: adverse upper bound */
void phase2a2(double trueprob, double pNull, double pp, 
	     double a, double b, int nmin, int Nmax, FILE *fp, int type)
{
    double p_stop;  int quantile[5],  *bound; int out;
    int i, m, k, K, total_hit, result[TRIALSIZE]; double dice;
    char *st1, *temp;
      
    if (type == 1) {
        bound = phase2a_lowerbound(pNull, pp, a, b, Nmax);   
/*        bound = phase2a_upperbound(pNull, pp, a, b, Nmax);
          for (i = 0; i < Nmax; i++) bound[i] -= 1;
          */
/*        K = 0;
          while( bound[K] > 0 ) ++K;  /* number of check points */
    	total_hit = 0;  
    	for (i = 0; i< TRIALSIZE; i++) {	
	    /* m = nmin;    /* m = 0; */
	    out = 0; 
	    for (k = 1; k < Nmax; k++) { /* generate outcome counts */
		dice = (double) genunf((float)0, (float)1);
		if ( dice < trueprob ) ++out;
                
		/* check lower bound */
                /*	   if (k == bound[m]) {           */
                /*  if (out <= m) { /* hit */
		/*	result[i] = bound[m]; 
		  	++total_hit;  
                        break;
                        }
                        ++m; 
                        } */
                if ( out <= bound[k] && k >= nmin) { /* hit */
		    result[i] = k; 
		    ++total_hit;  
		    break;
		}
	    }
            if (k == Nmax) result[i] = Nmax;
	    /* if (m == K) result[i] = Nmax; /* complete the trial */
	}
    }
    if (type == 2) { /* adverse event */
	bound = phase2a_upperbound(pNull, pp, a, b, Nmax);
	total_hit = 0;
	for (i = 0; i< TRIALSIZE; i++) {
	    out = 0;
	    for (k = 1; k < Nmax; k++) { /* generate outcome counts */
		dice = (double) genunf((float)0e0, (float)1e0);
		if ( dice < trueprob )  ++out;
		
		 /* check upper bound */
		if ( out >= bound[k] && k >= nmin) { /* hit */
		    result[i] = k; 
		    ++total_hit;  
		    break;
		}
	    }
	    if (k == Nmax ) result[i] = Nmax; /* complete the trial */
	}
    }
    /* result */
    p_stop = (double) total_hit / TRIALSIZE;    
    qsort(result, TRIALSIZE, sizeof(int), intcompare); 
    quantile[0] = result[(int)(TRIALSIZE* .10)];
    quantile[1] = result[(int)(TRIALSIZE* .25)]; 
    quantile[2] = result[(int)(TRIALSIZE* .50)];
    quantile[3] = result[(int)(TRIALSIZE* .75)];
    quantile[4] = result[(int)(TRIALSIZE* .90)];    
    /* print out the result */
    printf("%.3f %.3f  ", pNull, pp); 
    fprintf(fp, "%.3f %.3f  ", pNull, pp);
  
    printf("  %.3lf   ", p_stop);  fprintf(fp, "  %.3lf   ", p_stop);
    for (i = 0; i< 5; i++) {
	printf("%2d  ", quantile[i]);  fprintf(fp, "%2d  ", quantile[i]);
    }
    printf("\n");  fprintf(fp, "\n");
    
    st1 = (char*) calloc(150, sizeof(char));
    temp = (char*) calloc(20, sizeof(char));
    if (!st1 || !temp) {
	printf("Error: memory allocation fails in phase IIA.\n"); 
	exit(0);
    }
    if (type == 1) { /* print lower bounds */
        printf("Boundary (lower bounds):\n"); 
        fprintf(fp, "Boundary (lower bounds):\n");
        (void) sprintf(temp, " %2d/%2d\n", bound[nmin], nmin);
        st1 = strcat(st1, temp);
        for (i = nmin + 1; i < Nmax; i++) { 
            if ( bound[i] != bound[i-1] && bound[i] <= i ) {
                (void) sprintf(temp, " %2d/%2d\n", bound[i], i);
                st1 = strcat(st1, temp); 
            }
        }
        printf("%s\n", st1);	fprintf(fp, "%s\n", st1); 
    }
    if (type == 2) { /* print upper bounds */
        printf("Boundary (upper bounds):\n"); 
        fprintf(fp, "Boundary (upper bounds):\n");
        (void) sprintf(temp, " %2d/%2d\n", bound[nmin], nmin);
        st1 = strcat(st1, temp);
        for ( i = nmin + 1; i < Nmax; i++) {
            if ( bound[i] != bound[i-1] && bound[i] <= i ) {
                (void) sprintf(temp, " %2d/%2d\n", bound[i], i);
                st1 = strcat(st1, temp);
            }
        }
	printf("%-30s ", st1);
	fprintf(fp, "%-30s ", st1);
    }
    free(bound); free(st1); free(temp);
/*---end of phase2a2()-----*/
}

